{***********
GULPBITS.PAS
***********}

PROCEDURE ErrorMessage(I : Integer); FORWARD;

PROCEDURE UpperCase(VAR F : FileType);
  VAR I : INTEGER;
  BEGIN
  FOR I := 1 TO LENGTH(F) DO
    F[I] := UPCASE(F[I]);
  END {of uppercase};

PROCEDURE ConvertKeyToIBM (VAR Ch1 : CHAR);
  VAR Ch2 : CHAR;
  BEGIN
  IF (Ch1 = #0) THEN
    BEGIN
    Ch2 := READKEY;
    CASE Ch2 OF
      #72 : Ch1 := ^E;
      #80 : Ch1 := ^X;
      #75 : Ch1 := ^S;
      #77 : Ch1 := ^D;
      #83 : Ch1 := #127;
      #15,#115 : Ch1 := ^A;
      #116 : Ch1 := ^F;
      #73 : Ch1 := ^R;
      #81 : Ch1 := ^C;
      #71 : Ch1 := HomeKey;
      #79 : Ch1 := EndKey;
      #59 : Ch1 := F1Key;
      ELSE Ch1 := #0;
      END {of case};
    END {of if};
  END {of convertkeytoibm};

PROCEDURE LowVideo;
  BEGIN
  IF ForegroundColor < 8 THEN TextColor(ForegroundColor+8)
  ELSE TextColor(ForegroundColor-8);
  TextBackground(BackgroundColor);
  END;

PROCEDURE NormVideo;
  BEGIN
  TextColor(ForegroundColor);
  TextBackground(BackgroundColor);
  END;

PROCEDURE InverseVideo;
  BEGIN
  IF ForegroundColor < 8 THEN TextBackground(ForegroundColor)
  ELSE TextBackground(ForegroundColor-8);
  TextColor(BackgroundColor);
  END {of inverseviseo};

{**********}

FUNCTION Exist (FileName : FileType) : BOOLEAN;
  VAR
    F : FILE;
    Result : INTEGER;
  BEGIN
  ASSIGN(F,FileName);
  {$I-} RESET(F); { $I+}
  Result := IORESULT;
  EXIST := (Result = 0);
  IF Result = 0 THEN CLOSE(F);
  END {of exist};

PROCEDURE Centre (S:ScreenString);
  VAR
    I : 1..ScreenWidth;
  BEGIN
  FOR I := 1 TO (ScreenWidth - LENGTH(S)) DIV 2 DO WRITE(' ');
  WRITE(S);
  END;

PROCEDURE Clear;
  BEGIN
  CLRSCR;
  Centre(Version); WRITELN;
  END;

PROCEDURE Message (S : ScreenString);
  BEGIN
  GOTOXY(1,ScreenHeight);
  Centre(S);
  CLREOL;
  END {of message};

FUNCTION IntToStr(I,W : Integer) : String;
  VAR S : String;
  BEGIN
  IF W > 0 THEN STR(I:W,S)
  ELSE STR(I,S);
  IntToStr := S;
  END;

FUNCTION RealToStr(R:RealType; W,D : Integer) : String;
  VAR S : String;
  BEGIN
  IF (D >= 0) THEN STR(R:W:D,S)
  ELSE IF (W > 0) THEN STR(R:W,S)
  ELSE STR(R,S);
  RealToStr := S;
  END;

FUNCTION PadStr(S: String; W : INTEGER) : STRING;
  BEGIN
  WHILE LENGTH(S) < W DO S := ' '+S;
  IF LENGTH(S) > W THEN S := COPY(S,1,W);
  PadStr := S;
  END;

FUNCTION FillStr(S: String; W : INTEGER) : STRING;
  BEGIN
  WHILE LENGTH(S) < W DO S := S+' ';
  IF LENGTH(S) > W THEN S := COPY(S,1,W);
  FillStr := S;
  END;

PROCEDURE Pause;
  VAR Ch : CHAR;
  BEGIN
  WRITELN;
  Centre('Press any key');
  Ch := READKEY;
  END {of pause};

PROCEDURE GetChar(VAR Ch : CHAR; CharSet : CharSetType);
  BEGIN
  REPEAT
    Ch := READKEY;
    Ch := UPCASE(Ch);
    ConvertKeyToIBM(Ch);
  UNTIL Ch IN CharSet;
  IF Ch IN [#32..#126] THEN WRITE(Ch);
  END;

PROCEDURE ReadFileName(VAR F:FileType;G:FileType;Posn:INTEGER;VAR Aborted:BOOLEAN);
  VAR
    FileName : FileType;
    Ch : CHAR;
    Letter : Byte;

  FUNCTION DotTyped(S:FileType) : BOOLEAN;
    VAR N : INTEGER;
    BEGIN
    N := LENGTH(S);
    WHILE NOT (S[N] IN ['.',':','\']) AND (N > 1) DO
      N := N - 1;
    DotTyped := S[N] = '.';
    END;

  PROCEDURE GetString(VAR S:FileType; Posn:INTEGER; VAR Aborted:BOOLEAN);
    VAR
      Max, L : INTEGER;
      FirstChar : BOOLEAN;
      OKChars : CharSetType;
    BEGIN
    FirstChar := TRUE;
    IF S = DirMask THEN OKChars := FileChars + ['*','?']
    ELSE OKChars := FileChars;
    Max := LENGTH(S)+1;
    REPEAT
      GOTOXY(Posn,ScreenHeight);
      WRITE(S);
      CLREOL;
      L := LENGTH(S);
      Ch := ReadKey;
      Ch := UPCASE(Ch);
      ConvertKeyToIBM(Ch);
      IF FirstChar THEN BEGIN
        IF Ch <> ^M THEN BEGIN
          IF Ch IN OKChars THEN BEGIN
            S := DirString+Ch;
            Max := LENGTH(S) + 7;
            END
          ELSE BEGIN
            IF Ch = '\' THEN S := Ch;
            Max := LENGTH(S) + 8;
            END;
          END;
        FirstChar := FALSE;
        END
      ELSE IF (Ch IN OKChars) AND (L < Max)
        OR (S[LENGTH(S)] IN OKChars) AND
          ((Ch = ':') AND (L = 1) OR (Ch = '.') AND NOT DotTyped(S) OR (Ch = '\'))
          OR (Ch = '\') AND (S[L] = ':')
          THEN S := S + Ch;
      IF (L > 0) AND (Ch IN [^S,^H,#127]) THEN DELETE(S,LENGTH(S),1);
      IF (S[LENGTH(S)] = '\') OR (S[LENGTH(S)] = ':') THEN Max := LENGTH(S)+8
      ELSE IF S[LENGTH(S)] = '.' THEN Max := LENGTH(S)+3;
      IF (Ch = #27) AND (LENGTH(S)>0) THEN
        BEGIN
        Ch := ' ';
        S := '';
        Max := 8;
        END;
    UNTIL (Ch = ^M) OR (Ch=#27) AND (LENGTH(S) = 0);
    IF Ch = #27 THEN Aborted := TRUE ELSE Aborted := FALSE;
    END {of getstring};

  BEGIN { readfilename }
  FileName := F;
  GetString(FileName,Posn,Aborted);
  IF (LENGTH(FileName) > 0) AND (NOT Aborted) THEN
    BEGIN
    IF NOT DotTyped(FileName) THEN FileName := FileName + '.' + G;
    F := FileName;
    END;
  END {of readfilename};

FUNCTION IOError : Boolean;
  BEGIN
  ErrorCode := IORESULT;
  IF ErrorCode <> 0 THEN BEGIN
    ErrorMessage(I);
    PAUSE;
    Clear;
    END;
  IOError := (ErrorCode <> 0);
  END {IOError};

PROCEDURE AssignDest (Ext : FileType;VAR Aborted:BOOLEAN);
  VAR I : INTEGER;
  BEGIN
  IF Dest = 'Screen' THEN
    BEGIN
    ASSIGN(OutChan,'');
    CLRSCR;
    END
  ELSE IF Dest = 'Printer' THEN ASSIGN(OutChan,'LPT1')
  ELSE
    BEGIN
    I := POS('.',WorkFile)-1;
    IF I = -1 THEN I := LENGTH(WorkFile);
    OutFile := COPY(WorkFile,1,I) + '.' + Ext;
    Aborted := FALSE;
    IF Mode <> 'Batch' THEN
      BEGIN
      GOTOXY(1,25);CLREOL;
      WRITE('Enter file name : ');
      ReadFileName(OutFile,Ext,19,Aborted);
      END;
    IF NOT Aborted THEN ASSIGN(OutChan,OutFile);
    END;
  REWRITE(OutChan);
  IF IOError THEN Aborted := TRUE;
  END {of assigndest};

PROCEDURE ErrorMessage(I : Integer);
  VAR
    J : INTEGER;
  BEGIN
  PrintPageStopped := TRUE;
  Clear;WRITELN;WRITELN;
  Centre('Error');WRITELN;
  WRITE(' ':5);
  FOR J := 1 TO 70 DO WRITE(#196);
  WRITELN;WRITELN;
  CASE I OF
    100: Centre('Disk read error');
    101: Centre('Disk write error');
    102: Centre('File not assigned');
    103: Centre('File not open');
    104: Centre('File not open for input');
    105: Centre('File not open for output');
    106: Centre('Invalid numeric format');
    150: Centre('Disk is write protected');
    151: Centre('Unknown unit');
    152: Centre('Printer or disk drive not ready');
    153: Centre('Unknown command');
    154: Centre('CRC error in data');
    155: Centre('Bad drive request structure length');
    156: Centre('Disk seek error');
    157: Centre('Unknown media type');
    158: Centre('Sector not found');
    159: Centre('Printer out of paper');
    160: Centre('Device write fault');
    161: Centre('Device read fault');
    162: Centre('Hardware failure');
    200: Centre('Division by zero');
    201: Centre('Range check error');
    202: Centre('Stack overflow error');
    203: Centre('Heap overflow error');
    204: Centre('Invalid pointer operation');
    205: Centre('Floating point overflow');
    206: Centre('Floating point underflow');
    207: Centre('Invalid floating point operation');
    1001 : BEGIN
      Centre(WorkFile+' is not a valid data file.');WRITELN;
      Centre('NAME line not found.');
      END;
    1002 : BEGIN
      STR(MaxNoCols,S);
      Centre('Too many columns in '+WorkFile+'. GULP can only');WRITELN;
      Centre('accept ' + S + ' columns. Ignoring excess.');
      END;
    1003 : Centre('No rows in data file');
    1004 : Centre('Error in numeric format: '+S);
    1005 : Centre('No columns in data file');
    1006 : Centre('Duplicate row names in data file : ' + S);
    1007 : BEGIN
      STR(MaxNoRows,S);
      Centre('Too many rows in data file. There is only enough');WRITELN;
      Centre('memory available for ' + S + ' rows.');WRITELN;
      WRITELN;
      Centre('Alternatively, check that your data file includes a COLUMNS label.');
      END;
    1008 : Centre('No limit or right hand side coefficients in data file');
    1009 : BEGIN
      Centre('A row name in the COLUMNS section of the data');WRITELN;
      Centre('file does not match the list of row names.   ');WRITELN;WRITELN;
      Centre('Row name not found                 : ' + ThisRowName);WRITELN;
      Centre('Column in which row name contained : ' + ThisColName);
      END;
    1010 : BEGIN
      Centre('A constraint type in data file is not one of');WRITELN;
      Centre('L, E, G or N.');
      END;
    1011 : Centre('Two objective functions found in data file');
    1012 : Centre('RHS label not found in data file');
    1013 : Centre('ENDATA label not found in data file');
    1015 : Centre('Objective function not found in data file');
    1016 : Centre('Unexpected end of file reading column data');
    1017 : Centre('Unexpected end of file reading RHS data');
    1018 : BEGIN
           Centre('GULP has unexpectedly run out of memory. You may be able'); WRITELN;
           Centre('to free up enough RAM by editing AUTOEXEC.BAT and/or'); WRITELN;
           Centre('CONFIG.SYS and then restarting (i.e. resetting) your computer.');  WRITELN;
           Centre('GULP will now halt.');
           END;
    1019 : BEGIN
           Centre('Not enough RAM available. GULP requires at least 180K'); WRITELN;
           Centre('of RAM to be available. You may be able to free up'); WRITELN;
           Centre('enough RAM by editing AUTOEXEC.BAT and/or CONFIG.SYS'); WRITELN;
           Centre('and then restarting (i.e. resetting) your computer.');  WRITELN;
           Centre('GULP will now halt.');
           END;
    1020 : Centre('Help file GULP.HLP not found.');
    1021 : BEGIN
           IF POS('\',WorkFile) = 0 THEN WorkFile := DirString+WorkFile;
           Centre('File '+WorkFile+' not found.');
           END;
    END {of case};
  WRITELN;WRITELN;
  WRITE(' ':5);
  FOR J := 1 TO 70 DO WRITE(#196);
  WRITELN;
  IF I > 300 THEN BEGIN
    Pause;
    Clear;
    END;
  END {of errormessage};

PROCEDURE CarefulWrite(Dest: NameType; VAR Outchan: TEXT; LN : BOOLEAN;
    S: STRING; VAR ErrorCode: INTEGER);
  VAR
    Abort : BOOLEAN;
    Ch : CHAR;
  BEGIN
  {$I-}
  Abort := FALSE;
  REPEAT
    IF Dest = 'Screen' THEN
      IF LN THEN WRITELN(S)
      ELSE WRITE(S)
    ELSE
      IF LN THEN WRITELN(OutChan,S)
      ELSE WRITE(OutChan,S);
    ErrorCode := IORESULT;
    IF ErrorCode <> 0 THEN BEGIN
      ErrorMessage(ErrorCode);
      Message('Abort, Retry or Ignore? (A, R or I):');
      REPEAT
        Ch := UPCASE(READKEY);
      UNTIL Ch IN ['A','R','I'];
      IF Ch = 'A' THEN Abort := TRUE
      ELSE IF Ch = 'I' THEN ErrorCode := 0;
      Clear;
      IF Ch = 'R' THEN Message('Retrying. Please wait ...')
      ELSE IF Ch = 'I' THEn Message('Ignoring error and continuing. Please wait ...');
      END {if};
  UNTIL (ErrorCode = 0) OR Abort;
  END {carefulwrite};

PROCEDURE TitleScreen;
  BEGIN
  NormVideo;
  CLRSCR;
  GOTOXY(1,1);
  WRITELN(' ':9,'Ŀ');
  WRITELN(' ':9,'                            GULP                            ');
  WRITELN(' ':9,'         General, User-friendly Linear Programming          ');
  WRITELN(' ':9,'                                                            ');
  WRITELN(' ':9,'                 Version 4.42  4 May 1997                   ');
{$IFDEF WILEY}
  WRITELN(' ':9,'Ĵ');
  WRITELN(' ':9,'             This software is distributed with              ');
  WRITELN(' ':9,'       "Introduction to Practical Linear Programming"       ');
  WRITELN(' ':9,'                    by David J. Pannell                     ');
  WRITELN(' ':9,'            John Wiley and Sons, New York, 1997             ');
{$ENDIF}
  WRITELN(' ':9,'ٱ');
  WRITELN(' ':9,'  ');
{$IFDEF WILEY}
  WRITELN;
  WRITELN(' ':3,'Copyright (c) John Wiley & Sons, Inc., 1996,97.  All rights reserved.');
  WRITELN(' ':3,'Reproduction or translation of any part of this work beyond that permitted');
  WRITELN(' ':3,'in Section 117 of the 1976 United States Copyright Act without the express');
  WRITELN(' ':3,'written permission of the copyright owner is unlawful.  Requests for');
  WRITELN(' ':3,'permission or further information should be addressed to the Permissions');
  WRITELN(' ':3,'Department, John Wiley & Sons, Inc., 605 Third Avenue, New York, New York');
  WRITELN(' ':3,'10158.  The purchaser may make back-up copies for his/her own use only and');
  WRITELN(' ':3,'not for distribution or resale.  The Publisher assumes no responsibility');
  WRITELN(' ':3,'for errors, omissions, or damages, including, without limitation, damages');
  WRITELN(' ':3,'caused by the use of this program or from the information contained herein.');
{$ENDIF}
  END;

PROCEDURE ReadDefaults;
  VAR
    N : BYTE;
  BEGIN
  InFile := GulpDir+ProgName+'.CFG';
  IF Exist(InFile) THEN
    BEGIN
    ASSIGN(InChan,InFile);
    RESET(InChan);
    IF IOError THEN EXIT;
    READLN(InChan,Ch);
    CASE UPCASE(Ch) OF
      'B' : Mode := 'Batch';
      'M' : Mode := 'Matrix';
      'C' : Mode := 'Col name';
      'R' : Mode := 'Row name';
      'r' : Mode := 'row Type';
      'P' : Mode := 'Prob name';
      END;
    READLN(InChan,WorkFile); UpperCase(WorkFile);
    READLN(InChan,Problem.Aim); UpperCase(WorkFile);
    IF Problem.Aim <> 'MAX' THEN Problem.Aim := 'MIN';
    READLN(InChan,ColWidth);
    READLN(InChan,Dec);
    READLN(InChan,Ch);
    CASE UPCASE(Ch) OF
      'P' : Dest := 'Printer';
      'F' : Dest := 'File';
      ELSE  Dest := 'Screen';
      END;
    READLN(InChan,Ch); IncludeCols := UPCASE(Ch) = 'Y';
    READLN(InChan,Ch); IncludeRows := UPCASE(Ch) = 'Y';
    READLN(InChan,Ch); IncludeRange := UPCASE(Ch) = 'Y';
    READLN(InChan,PrinterWidth);
    READLN(InChan,DirString);
    UpperCase(DirString);
    {$I-}
    N := LENGTH(DirString);
    IF (DirString[N] = '\') AND (N > 1) THEN
      IF (DirString[N-1] <> ':') THEN DELETE(DirString,N,1);
    IF (DirString[2] = ':') AND (N = 2) THEN BEGIN
      N := INTEGER(DirString[1]) - 64;
      GetDir(N,DirString);
      IF IORESULT <> 0 THEN DirString := '.';
      END;
    ChDir(DirString);
    IF IORESULT <> 0 THEN BEGIN END;
    { $I+}
    GetDir(0,DirString);
    if DirString[length(DirString)] <> '\' then DirString := DirString + '\';
    DirMask := DirString+'*.GLP';
    InitString := '';
    WHILE NOT EOLN(InChan) DO
      BEGIN
      READ(InChan,I);
      IF NOT EOLN(InChan) THEN READ(InChan,Ch);
      InitString := InitString + CHAR(I);
      END;
    READLN(InChan);
    ResetString := '';
    WHILE NOT EOLN(InChan) DO
      BEGIN
      READ(InChan,I);
      IF NOT EOLN(InChan) THEN READ(InChan,Ch);
      ResetString := ResetString + CHAR(I);
      END;
    READLN(InChan);
    READLN(InChan,Ch);
    IF UPCASE(Ch) = 'S' THEN Method1 := Steepest
    ELSE Method1 := Highest;
    READLN(InChan,Ch);
    IF UPCASE(Ch) = 'S' THEN Method2 := Steepest
    ELSE Method2 := Highest;
    READLN(InChan,Ch); DropIntoEditor := UPCASE(Ch) = 'Y';
    IF NOT EOF(InChan) THEN READLN(InChan,ForegroundColor);
    IF NOT EOF(InChan) THEN READLN(InChan,BackgroundColor);
    CLOSE(InChan);
    IF IOError THEN ;
    END {of if}
  ELSE
    BEGIN
    Mode := 'Matrix';
    WorkFile := 'DEFAULT.GLP';
    Problem.Aim := 'MAX';
    ColWidth := 9;
    Dec := 2;
    Dest := 'Screen';
    IncludeCols := TRUE;
    IncludeRows := TRUE;
    IncludeRange := FALSE;
    PrinterWidth := 80;
    InitString := '';
    ResetString := '';
    Method1 := Highest;
    Method2 := Highest;
    DropIntoEditor := FALSE;
    ForegroundColor := 10;
    BackgroundColor := 1;
    END {of else};
  IF PARAMCOUNT > 0 THEN
    BEGIN
    WorkFIle := PARAMSTR(1);
    UpperCase(WorkFile);
    IF POS('.',WorkFile) = 0 THEN WorkFile := WorkFile + '.GLP';
    END;
  IF PARAMCOUNT > 1 THEN
    BEGIN
    S := PARAMSTR(2);
    UpperCase(S);
    IF (S = 'MAX') OR (S = 'MIN') THEN Problem.Aim := S;
    END;
  IF PARAMCOUNT > 2 THEN
    BEGIN
    S := PARAMSTR(3);
    IF UPCASE(S[1]) = 'B' THEN Mode := 'Batch';
    END;
  WITH Problem DO IF Aim = 'MAX' THEN Multiplier := 1 ELSE MULTIPLIER := -1;
  R := 0; SR := 1; FirstRow := 0; TopRow := 0; BotRow := 0;
  C := 0; SC := 1; FirstCol := 0; TopCol := 0; BotCol := 0;
  NormVideo;
  END {of read defaults};

PROCEDURE InitialSetUp;
  VAR
    I, J : INTEGER;
    Ch : CHAR;
  BEGIN
  FirstTime := TRUE;
  KeepSoln := TRUE;
  GETDIR(0,DirString);
  IF DirString[LENGTH(DirString)] <> '\' THEN DirString := DirString + '\';
  GulpDir := DirString;
  DirMask := DirString+'*.GLP';
  ControlCardFile := GulpDir + ProgName + '.$$1';
  BoundsFile := GulpDir + ProgName + '.$$2';
  RowsAvail := (MEMAVAIL-10000) DIV 2016;
  IF RowsAvail < 25 THEN BEGIN
    ReadDefaults;
    ErrorMessage(1019);
    Clear;
    HALT;
    END
  ELSE IF RowsAvail < MaxNoRows THEN MaxNoRows := RowsAvail;
  HelpFileName := GULPDir+ProgName+'.HLP';
  IF NOT Exist(HelpFileName) THEN BEGIN
    FileStr := FSearch('GULP.HLP',GetEnv('PATH'));
    IF FileStr = '' THEN HelpFileName := GULPDir+ProgName+'.HLP'
    ELSE HelpFileName := FExpand(FileStr);
    END;
  SLNFileName := GULPDir+ProgName+'.SLN';
  IF NOT Exist(SLNFileName) THEN BEGIN
    FileStr := FSearch('GULP.SLN',GetEnv('PATH'));
    IF FileStr = '' THEN SLNFileName := GULPDir+ProgName+'.SLN'
    ELSE SLNFileName := FExpand(FileStr);
    END;
  END {of initialsetup};

PROCEDURE Initialise (Rows : Rowtype; Cols : Coltype);
  VAR
    Row : RowType;
    Col : ColType;
    S : STRING[12];
  BEGIN
  FOR Row := ObjFn TO Rows DO
    BEGIN
    IF FirstTime THEN NEW(A[Row]);
    FOR Col := RHS TO Cols DO
      A[Row]^[Col] := 0;
    END;
  FOR Row := ObjFn TO Rows DO
    BEGIN
    ConstraintType[Row] := 'L';
    STR(Row:1,S);
    RowName[Row] := 'Row ' + S + '     ';
    ActThisCol[-Row] := -Row;
    ColThisAct[-Row] := -Row;
    END;
  FOR Col:= RHS TO Cols DO
    BEGIN
    STR(Col:1,S);
    ColName[Col] := 'Col ' + S + '     ';
    ActThisCol[Col] := Col;
    ColThisAct[Col] := Col;
    END;
  Problem.Name := 'Gulp      ';
  NoRows := 0;
  NoCols := 0;
  NoGs := 0;
  It := -1;
  ColName[RHS] := 'Limit     ';
  RowName[ObjFn] := 'Objective ';
  ConstraintType[ObjFn] := 'N';
  JumpToEditor := FALSE;
  StopSolve := FALSE;
  Aborted := FALSE;
  END {of initialise};

PROCEDURE Directory(DirMask : ScreenString);

TYPE
  AnyString = STRING[20];
VAR
  DirEntry : ARRAY[1..256] OF SearchRec;
  I, FileCount : INTEGER;
  Error : INTEGER;

Procedure LoadDirectory(DirMask : ScreenString; Error : INTEGER);
  VAR
    Temp, Count : INTEGER;
    DirInfo:SearchRec;
  BEGIN
  FileCount := 1;
  FINDFIRST(DirMask,Archive,dirinfo);
  Error := DOSERROR;
  IF Error = 0 THEN WHILE DOSError = 0 DO BEGIN
    Direntry[FileCount] := DirInfo;
    FindNext(DirInfo);
    FileCount := FileCount +1;
    END;
  FileCount := FileCount - 1;
  END {loaddirectory};

BEGIN {directory}
Clear;
LoadDirectory(DirMask,Error);
IF Error = 2 THEN Centre('Mask : '+DirMask+'  ... Directory not found')
ELSE if Error = 18 THEN Centre('Mask : '+DirMask+'  ... No files found.')
ELSE BEGIN
  WRITELN;
  Centre('Mask : '+DirMask); WRITELN;
  FOR I := 1 TO ScreenWidth DO WRITE(BarChar);
  GOTOXY(1,5);
  WRITE(' ':8,'____Name____  _Size_  ');
  WRITE('____Name____  _Size_  ');
  WRITELN('____Name____  _Size_');
  WINDOW(1,6,80,22);
  GOTOXY(1,1);
  FOR I := 1 TO FileCount DO
    BEGIN
    IF I MOD 3 = 1 THEN WRITE(' ':8);
    WRITE(DirEntry[I].Name:12);
    WRITE(DirEntry[I].Size:8);
    IF I MOD 3 = 0 THEN WRITELN ELSE WRITE(' ':2);
    END;
  WINDOW(1,1,80,25);
  END {else};
END;

PROCEDURE Load (VAR WorkFile : FileType);
  LABEL 999;
  TYPE
    Link = ^RowRec;
    RowRec = RECORD
               Name : NameType;
               No   : RowType;
               Left,Right : Link;
             END {of record};

VAR
  Pntr,TreeRoot : Link;
  S        : ScreenString;
  LastColName : NameType;
  Ch       : CHAR;
  R        : RowType;
  C        : ColType;
  StrPos, NumChs : INTEGER;
  TooManyRows, StopLoading : BOOLEAN;
  F : File;

PROCEDURE Skip (I : INTEGER);
  VAR J : INTEGER;
  BEGIN
  J := 0;
  WHILE (J < I) AND (NOT EOLN(InChan)) DO
    BEGIN
    READ(InChan,Ch);
    J := J + 1;
    END {of while};
  END {of skip};

FUNCTION Find (N : NameType) : BOOLEAN;
  VAR
    Found : BOOLEAN;
    P     : Link;
    UpN : NameType;
  BEGIN
  UpN := N;
  UpperCase(UpN);
  P := TreeRoot;
  Found := P^.Name = UpN;
  Pntr := P;
  WHILE NOT Found AND (P <> NIL) DO
    BEGIN
    Pntr := P;
    Found := P^.Name = UpN;
    IF UpN < P^.Name THEN P := P^.Left
    ELSE P := P^.Right;
    END {of while};
  Find := Found;
  END {of find};

PROCEDURE ReadRowNames;
  LABEL 999;
  VAR
    R : RowType;
    T : CHAR;
    N : NameType;
    I : INTEGER;
    UpN : NameType;

  PROCEDURE Insert (N : NameType; R : RowType);
    VAR
      P : Link;
    BEGIN
    UpN := N; UpperCase(UpN);
    NEW(P);
    P^.Name := UpN;
    P^.No   := R;
    P^.Left := NIL;
    P^.Right:= NIL;
    IF UpN < Pntr^.Name THEN Pntr^.Left := P
    ELSE Pntr^.Right := P;
    END {of insert};

 BEGIN {readrownames}
 R := 0; ConstraintType[ObjFn] := 'L';
 TreeRoot := NIL;
 TooManyRows := FALSE;
 {$I-}
 READ(InChan,Ch);
 IF Ch <> ' ' THEN
   BEGIN
   StopLoading := TRUE;
   ErrorMessage(1003);
   GOTO 999;
   END;
 I := 1; Ch := ' '; T := ' ';
 REPEAT
   READ(InChan,Ch);
   I := I + 1;
   IF Ch <> ' ' THEN T := UPCASE(Ch);
 UNTIL (I = 4);
 IF NOT (T IN ['E','L','G','N']) THEN
   BEGIN
   ErrorMessage(1010);
   T := 'L';
   END;
 READLN(InChan,N);
 N := N + '         ';
 IF T <> 'N' THEN R := 1;
 NEW(TreeRoot);
 UpN := N; UpperCase(UpN);
 TreeRoot^.Name := UpN;
 TreeRoot^.No   := R;
 TreeRoot^.Left := NIL;
 TreeRoot^.Right:= NIL;
 RowName[R] := N;
 ConstraintType[R] := T;
 READ(InChan,Ch);
 WHILE (Ch <> 'C') AND NOT EOF(InChan) DO
   BEGIN
   I := 0; Ch := ' '; T := ' ';
   REPEAT
     READ(InChan,Ch);
     I := I + 1;
     IF Ch <> ' ' THEN T := UPCASE(Ch);
   UNTIL (I = 3);
   IF  NOT (T IN ['E','L','G','N']) THEN
     BEGIN
     ErrorMessage(1010);
     T := 'L';
     END;
   READLN(InChan,N);
   N := N + '         ';
   IF T <> 'N' THEN
     BEGIN
     R := R + 1;
     IF R > MaxNoRows THEN
       IF NOT TooManyRows THEN
         BEGIN
         ErrorMessage(1007);
         TooManyRows := TRUE;
         END
       ELSE
     ELSE
       BEGIN
       RowName[R] := N;
       ConstraintType[R] := T;
       END;
     IF Find(N) THEN
       BEGIN
       S := N;
       ErrorMessage(1006);
       END
     ELSE Insert(N,R);
     END {of if}
   ELSE {T = 'N'}
     IF ConstraintType[ObjFn] = 'N' {i.e. if already found objfn} THEN
       BEGIN
       ErrorMessage(1011);
       T := 'L';
       END
     ELSE {this is the objfn}
       BEGIN
       RowName[ObjFn] := N;
       ConstraintType[Objfn] := 'N';
       IF Find(N) THEN ErrorMessage(1006)
       ELSE Insert(N,ObjFn);
       END {of else & of higher else};
   IF NOT EOF(InChan) THEN READ(InChan,Ch);
   END {of while};
 { $I+}
 ErrorCode := IORESULT;
 IF ErrorCode <> 0 THEN ErrorMessage(1004);
 IF ConstraintType[0] <> 'N' THEN ErrorMessage(1015);
 NoRows := R;
 IF R > MaxNoRows THEN NoRows := MaxNoRows;
 999:END {of readrownames};

FUNCTION RowNumber (N : NameType) : RowType;
  BEGIN
  IF NOT Find(N) THEN
    BEGIN
    ThisColName := ColName[C];
    ThisRowName := N;
    ErrorMessage(1009)
    END {of if}
  ELSE RowNumber := Pntr^.No;
  END {of rownumber};

PROCEDURE FindRows (C : ColType);
  TYPE
    String12 = STRING[12];
  VAR
    String9 : STRING[9];
    N : REAL;
    Line : ScreenString;
    NStr : String12;
    Result : INTEGER;

  PROCEDURE RemoveBlanks(VAR S:String12);
    VAR I : INTEGER;
    BEGIN
    FOR I := LENGTH(S) DOWNTO 1 DO
      IF S[I] = ' ' THEN DELETE(S,I,1);
    END;

  FUNCTION NumberCanBeCorrected(S:String12; VAR N: REAL) : BOOLEAN;
    VAR
      B : BOOLEAN;
    BEGIN
    B := TRUE;
    IF S[1] = '.' THEN S := '0'+S
    ELSE IF COPY(S,1,2) = '-.' THEN INSERT('0',S,2)
    ELSE IF S[LENGTH(S)] = '.' THEN S := S + '0'
    ELSE B := FALSE;
    IF B THEN BEGIN
      Val(S,N,Result);
      IF Result <> 0 THEN B := FALSE;
      END;
    NumberCanBeCorrected := B;
    END;

  BEGIN
  {$I-}
  READLN(InChan,Line);
  ThisRowName := COPY(Line,1,10);
  R := RowNumber(ThisRowName);
  IF (R <= MaxNoRows) AND (C <= MaxNoCols) THEN BEGIN
    NStr := COPY(Line,11,12);
    RemoveBlanks(NStr);
    Val(NStr,N,Result);
    IF Result = 0 THEN A[R]^[C] := N
    ELSE IF NumberCanBeCorrected(NStr,N) THEN A[R]^[C]:=N
    ELSE BEGIN
      S := NStr;
      ErrorMessage(1004);
      END;
    END;
  IF LENGTH(Line) > 25 THEN BEGIN
    ThisRowName := COPY(Line,26,10);
    R := RowNumber(ThisRowName);
    IF (R <= MaxNoRows) AND (C <= MaxNoCols) THEN BEGIN
      NStr := COPY(Line,36,12);
      RemoveBlanks(NStr);
      Val(NStr,N,Result);
      IF Result = 0 THEN A[R]^[C]:=N
      ELSE IF NumberCanBeCorrected(NStr,N) THEN A[R]^[C]:=N
      ELSE BEGIN
       S := NStr;
        ErrorMessage(1004);
       END;
      END
    END;
  ErrorCode := IORESULT;
  IF ErrorCode <> 0 THEN ErrorMessage(1016);
  { $I+}
  END {of findrows};

PROCEDURE Chop(P:Link);
  BEGIN
  IF P^.Left <> NIL THEN Chop(P^.Left);
  IF P^.Right <> NIL THEN Chop(P^.Right);
  DISPOSE(P);
  END;

PROCEDURE StoreControlCards;
  VAR
    F : TEXT;
    More : BOOLEAN;
  BEGIN
  ASSIGN(F,ControlCardFile);
  REWRITE(F);
  IF IOError THEN EXIT;
  REPEAT
    WRITELN(F,S);
    More := NOT EOF(InChan);
    IF More THEN READLN(InChan,S);
  UNTIL (COPY(S,1,4)='NAME') OR NOT More;
  IF NOT More THEN BEGIN
    ErrorMessage(1001);
    HALT;
    END;
  CLOSE(F);
  IF IOError THEN ;
  END;

PROCEDURE StoreBounds;
  VAR
    F : TEXT;
    More : BOOLEAN;
  BEGIN
  READLN(InChan,S);
  S := Ch + S;
  ASSIGN(F,BoundsFile);
  REWRITE(F);
  IF IOError THEN EXIT;
  REPEAT
    WRITELN(F,S);
    More := NOT EOF(InChan);
    IF More THEN READLN(InChan,S);
  UNTIL (COPY(S,1,3)='END') OR NOT More;
  IF NOT More THEN  ErrorMessage(1013);
  CLOSE(F);
  IF IOError THEN ;
  END;

BEGIN {load}
StopLoading := FALSE;
ASSIGN(InChan,WorkFile);
RESET(InChan);
IF IOError THEN EXIT;
IF NOT EOF(InChan) THEN READLN(InChan,S);
UpperCase(S);
IF NOT (COPY(S,1,4) = 'NAME') THEN StoreControlCards
ELSE IF Exist(ControlCardFile) THEN BEGIN
  ASSIGN(F,ControlCardFile);
  Erase(F);
  IF IOError THEN ;
  END;
Problem.Name := COPY(S,15,10);
IF Problem.Name = '' THEN Problem.Name := 'GULP';
READLN(InChan); {skip 'rows'}
ReadRowNames;
IF StopLoading THEN GOTO 999;
READLN(InChan); {skip 'columns'}
C := 0;
LastColName := '';
ThisColName := 'z';
{$I-}
READ(InChan,Ch);
IF Ch <> ' ' THEN
  BEGIN
  ErrorMessage(1005);
  GOTO 999;
  END;
REPEAT
  Skip(3);
  READ(InChan,ThisColName);
  IF ThisColName <> LastColName THEN
    BEGIN
    C := C + 1;
    IF C <= MaxNoCols THEN ColName[C] := ThisColName;
    LastColName := ThisColName;
    END {of if};
  FindRows(C);
  READ(InChan,Ch);
  ErrorCode := IORESULT;
UNTIL (Ch = 'R') OR (C > MaxNoCols) OR (ErrorCode <> 0);
IF C > MaxNoCols THEN
  BEGIN
  ErrorMessage(1002);
  C := C - 1;
  REPEAT
    READLN(InChan);
    READ(InChan,Ch);
    ErrorCode := IORESULT;
  UNTIL (Ch = 'R') OR (ErrorCode <> 0);
  END;
IF Ch <> 'R' THEN ErrorMessage(1012)
ELSE IF ErrorCode <> 0 THEN ErrorMessage(1016);
IF NOT EOF(InChan) THEN BEGIN
  NoCols := C;
  READLN(InChan); {i.e. skip 'rhs'}
  READ(InChan,Ch);
  IF Ch = ' ' THEN
    BEGIN
    REPEAT
      Skip(3);
      READ(InChan,ColName[RHS]);
      FindRows(RHS);
      READ(InChan,Ch);
      ErrorCode := IORESULT;
    UNTIL (Ch <> ' ') OR (ErrorCode <> 0) OR (EOF(InChan));
    IF ErrorCode <> 0 THEN ErrorMessage(1004);
    IF EOF(InChan) THEN  ErrorMessage(1013);
    END {of if ch}
  ELSE ErrorMessage(1008);
  IF (Ch <> 'E') AND (NOT EOF(InChan)) THEN StoreBounds
  ELSE IF Exist(BoundsFile) THEN BEGIN
    ASSIGN(F,BoundsFile);
    Erase(F);
    IF IOError THEN ;
    END;
  END;
{ $I+}
Chop(TreeRoot);
CLOSE(InChan);
IF IOError THEN ;
999:END {of load};

PROCEDURE PrintSoln (CalcPassed : BOOLEAN);
  CONST
    MinReal = 1.0E-06;
    Down = 1;
    Up = 2;
  TYPE
    String12 = STRING[12];
    String42 = STRING[42];
    SolnType = RECORD
               SName : NameType;
               SType : BYTE;
               Value,Shadow,Original : RealType;
               Change : ARRAY[1..2] OF RealType;
               END;
  VAR
    R : RowType;
    C : ColType;
    X,Y : SolnType;
    F : FILE OF SolnType;
    Chng : RealType;
    L : 0..ScreenHeight;
    N : 1..2;
    Aborted,Calc,StopPrint : BOOLEAN;
    OriginalDest : NameType;
    Ch : CHAR;

  PROCEDURE TestStopPrint;
    VAR Ch : CHAR;
    BEGIN
    Ch := READKEY;
    IF KEYPRESSED THEN Ch := READKEY;
    IF (Ch IN [#27,^C]) THEN StopPrint := TRUE;
    END;

  FUNCTION TypeStr(I : INTEGER) : String20;
    VAR
      S : String20;
    BEGIN
    CASE I OF
      65: S := ' A ';
      68: S := ' AD';
      69: S := ' E ';
      169: S := ' ED';
      170: S := ' EM';
      71: S := ' G ';
      171: S := ' GD';
      172: S := ' GM';
      76: S := ' L ';
      176: S := ' LD';
      177: S := ' LM';
      77: S := ' ZM';
      78: S := ' N ';
      90: S := ' Z ';

      ELSE S := ' '+CHR(I)+' ';
      END {case};
    TypeStr := S;
    END {TypeStr};

  PROCEDURE PrintLine (V : BYTE; X : SolnType);
    VAR
      S1,S2 : STRING[12];
      S3 : STRING[11];
    BEGIN
    STR(X.Value:12:4,S1);
    STR(X.Shadow:12:4,S2);
    
    CarefulWrite(Dest, OutChan,FALSE,IntToStr(V,3)+' '+FillStr(X.SName,10)+
      TypeStr(X.SType)+S1+' '+S2,ErrorCode);
    IF ErrorCode <> 0 THEN Exit;
    IF IncludeRange THEN WITH X DO
      BEGIN
      Change[Down] := Change[Down] + Original;
      Change[Up]   := Change[Up]   + Original;
      STR(Change[Down]:11:4,S3);
      IF Change[Down] < -1.0E10 THEN BEGIN
        CarefulWrite(Dest,OutChan,FALSE,'  -INFINITY ',ErrorCode);
       IF ErrorCode <> 0 THEN Exit;
       END
      ELSE BEGIN
        CarefulWrite(Dest,OutChan,FALSE,' '+S3,ErrorCode);
        IF ErrorCode <> 0 THEN Exit;
        END;
      STR(Original:11:4,S3);
      CarefulWrite(Dest,OutChan,FALSE,' '+S3,ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      STR(Change[Up]:11:4,S3);
      IF Change[Up] > 1.0E10 THEN BEGIN
        CarefulWrite(Dest,OutChan,FALSE,'   INFINITY ',ErrorCode);
        IF ErrorCode <> 0 THEN Exit;
        END
      ELSE BEGIN
        CarefulWrite(Dest,OutChan,FALSE,' '+S3,ErrorCode);
        IF ErrorCode <> 0 THEN Exit;
        END;
      END;
    CarefulWrite(Dest,OutChan,TRUE,'',ErrorCode);
    IF ErrorCode <> 0 THEN Exit;
    END{of printline};

  PROCEDURE Pause;
    BEGIN
    IF Dest = 'Screen' THEN
      BEGIN
      Message('Press any key ([Esc] = abort)');
      TestStopPrint;
      WRITELN;
      END {of if};
    END {of pause};

  PROCEDURE CalcObjFnRange (C : ColType);
    VAR
      Col : ColType; Row : RowType;
      Tempo : RealType; {stores value of A[Row]^[Col] for later testing}
    BEGIN
    X.SName := ColName[C];
    X.Original := OriginalObjFn[C];
    X.Change[Down] := -1.0E+20;
    X.Change[Up]   :=  1.0E+20;
    IF ColThisAct[C] < 0 {col basic} THEN
      BEGIN
      Row := -ColThisAct[C];
      X.SType := 65; {A for active}
      X.Value := A[Row]^[RHS];
      IF X.Value < MinReal THEN X.SType := 68; {D for degenerate}
      X.Shadow := 0;
      FOR Col := 1 TO NoCols DO
        BEGIN
        Tempo := A[Row]^[Col];
        IF (A[ObjFn]^[Col] >= 0) AND (ABS(A[Row]^[Col]) > 1.0E-06) THEN
          BEGIN
          Chng := -Problem.Multiplier * A[ObjFn]^[Col]/A[Row]^[Col];
          IF (Chng < 0) AND (Chng > X.Change[Down]) THEN
            X.Change[Down] := Chng
          ELSE
            IF (Chng > 0) AND (Chng < X.Change[Up]) THEN
              X.Change[Up] := Chng
            ELSE
              {check for degeneracy and adjust range analysis if necessary}
              IF Chng = 0.0 THEN
                IF Tempo < 0.0 THEN X.Change[Up] := 0
                ELSE X.Change[Down] := 0.0;
          END {of if};
        END {loop on col};
      END {if col basic}
    ELSE {col not basic}
      BEGIN
      IF A[ObjFn]^[ColThisAct[C]] < MinReal THEN X.SType := 77 {M for multiple}
      ELSE X.SType := 90; {Z for zero}
      X.Value := 0;
      X.Shadow := A[ObjFn]^[ColThisAct[C]];
      Chng := Problem.Multiplier * A[ObjFn]^[ColThisAct[C]];
      IF Chng < 0 THEN N := 1 ELSE N := 2;
      X.Change[N] := Chng;
      END;
    END {of calcobjfnrange};

  PROCEDURE CalcRHSRange (R : RowType);
    VAR
      Constraint : RowType;
    BEGIN
    X.SName := RowName[R];
    X.SType := INTEGER(ConstraintType[R]);
    X.Original := OriginalRHS[R];
    X.Change[Down] := -1.0E+20;
    X.Change[Up]   :=  1.0E+20;
    IF CHR(X.SType) = 'L' THEN I := 1 ELSE {must be 'G'} I := 2;
    IF ColThisAct[-R] < 0 {row basic, i.e. slack} THEN
      BEGIN
      X.Value := A[-ColThisAct[-R]]^[RHS];
      IF X.Value < MinReal THEN X.SType := X.SType+100;
      X.Shadow := 0;
      X.Change[I] := A[-ColThisAct[-R]]^[RHS]*(I*2-3);
      END
    ELSE {row not basic}
      BEGIN
      X.Value := 0;
      X.Shadow := A[ObjFn]^[ColThisAct[-R]];
      IF X.Shadow < MinReal THEN X.SType := X.SType+101;
      IF ConstraintType[R] IN ['E','G'] THEN X.Shadow := -X.Shadow;
      FOR Constraint := 1 TO NoRows DO
        IF ABS(A[Constraint]^[ColThisAct[-R]]) > 1.0E-08 THEN
          BEGIN
          Chng := A[Constraint]^[RHS]/A[Constraint]^[ColThisAct[-R]]*(I*2-3);
          IF (Chng < 0) AND (Chng > X.Change[Down]) THEN
            X.Change[Down] := Chng
          ELSE IF (Chng > 0) AND (Chng < X.Change[Up]) THEN
            X.Change[Up] := Chng;
          END {of if and loop on constraint};
      END {of else};
    END {of calcrhsrange};

  PROCEDURE PrintVectors {print solution for either rows or columns}
            (Include, PrintingCols : BOOLEAN;
             Heading1              : String12;
             Heading2,Heading3     : String42;
             L {1st line on screen},
             NoVs {No Cols/Rows}   : BYTE);
    VAR
      V : BYTE;
    BEGIN
    IF Include AND NOT StopPrint THEN
      BEGIN
      CarefulWrite(Dest,OutChan,TRUE,'',ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      CarefulWrite(Dest,OutChan,TRUE,Heading1,ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      CarefulWrite(Dest,OutChan,TRUE,'-----------',ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      CarefulWrite(Dest,OutChan,TRUE,'',ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      CarefulWrite(Dest,OutChan,FALSE,Heading2,ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      IF IncludeRange THEN BEGIN
        CarefulWrite(Dest,OutChan,FALSE,Heading3,ErrorCode);
        IF ErrorCode <> 0 THEN Exit;
        END;
      CarefulWrite(Dest,OutChan,TRUE,'',ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      CarefulWrite(Dest,OutChan,FALSE,' -- ---------- - ------------ ------------',ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      IF IncludeRange THEN BEGIN
        CarefulWrite(Dest,OutChan,FALSE,' ----------- ----------- -----------',ErrorCode);
        IF ErrorCode <> 0 THEN Exit;
        END;
      CarefulWrite(Dest,OutChan,TRUE,'',ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      END {of if};
    V := 0;
    REPEAT
      REPEAT
        IF Include THEN L := L + 1;
        V := V + 1;
        IF Calc THEN
          BEGIN
          IF PrintingCols THEN CalcObjFnRange(V) ELSE CalcRHSRange(V);
          IF KeepSoln THEN WRITE(F,X);
          END
        ELSE READ(F,X);
        IF Include AND NOT StopPrint THEN PrintLine(V,X);
        IF ErrorCode <> 0 THEN Exit;
        IF KEYPRESSED THEN TestStopPrint;
      UNTIL (L = ScreenHeight-1) OR (V = NoVs);
      L := 2;
      IF Include AND NOT StopPrint THEN
        IF (V < NoVs) OR (PrintingCols AND IncludeRows) THEN Pause;
      IF (Dest = 'Screen') AND NOT (PrintingCols AND NOT Include) THEN
        IF (V < NoVs) OR (PrintingCols AND IncludeRows) THEN Clear;
    UNTIL V = NoVs;
    END {of printvectors};

BEGIN
OriginalDest:= Dest;
Calc := CalcPassed;
Aborted := FALSE;
REPEAT
  ASSIGN(F,SLNFileName);
  IF NOT Exist(SLNFileName) THEN BEGIN
    REWRITE(F);
    CLOSE(F);
    IF IOError THEN EXIT;
    END {if};
  StopPrint := FALSE;
  RESET(F);
  IF IOError THEN EXIT;
  IF Calc THEN
    BEGIN
    Y.SName := Problem.Name;
    Y.SType := It;
    Y.Value := A[ObjFn]^[RHS]*Problem.Multiplier;
    Y.Original := INT(Problem.Multiplier);
    Y.Change[1] := INT(NoCols);
    Y.Change[2] := INT(NoRows);
    WRITE(F,Y);
    END
  ELSE READ(F,Y);
  IF IncludeRows OR IncludeCols THEN
    BEGIN
    AssignDest('SOL',Aborted);
    IF Aborted THEN StopPrint := TRUE;
    IF NOT Aborted THEN
      BEGIN
      IF Dest = 'Screen' THEN ScreenLost := TRUE
      ELSE IF Dest = 'Printer' THEN
        BEGIN
        Message('Sending output to printer');
        CarefulWrite(Dest,OutChan,FALSE,InitString,ErrorCode);
        IF ErrorCode <> 0 THEN Exit;
        END
      ELSE IF Dest = 'File' THEN Message('Saving output in '+OutFile);
      CarefulWrite(Dest,OutChan,TRUE,Version+' ',ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      CarefulWrite(Dest,OutChan,TRUE,'',ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      CarefulWrite(Dest,OutChan,TRUE,'Optimal Solution',ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      CarefulWrite(Dest,OutChan,TRUE,'----------------',ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      CarefulWrite(Dest,OutChan,TRUE,'',ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      CarefulWrite(Dest,OutChan,TRUE,'Problem name             : '+Y.SName,ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      CarefulWrite(Dest,OutChan,FALSE,'Problem direction        : ',ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      IF Y.Original < 0 THEN CarefulWrite(Dest,OutChan,TRUE,'MIN',ErrorCode)
      ELSE CarefulWrite(Dest,OutChan,TRUE,'MAX',ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      CarefulWrite(Dest,OutChan,TRUE,'Objective function value : '+RealToStr(Y.Value,1,6),ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      CarefulWrite(Dest,OutChan,TRUE,'Number of iterations     : '+IntToStr(Y.SType,0),ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      L := 15;
      END;
    END;
  PrintVectors(IncludeCols,TRUE,'Activities',
               ' No    Name         Level     Shadow Cost ',
               '  Lower Obj   Objective   Upper Obj',L,TRUNC(Y.Change[Down]));
  IF ErrorCode <> 0 THEN Exit;
  IF IncludeCols THEN L := 7;
  PrintVectors(IncludeRows,FALSE,'Constraints',
               ' No    Name         Slack     Shadow Price',
               '  Lower Lim     Limit     Upper Lim',L,TRUNC(Y.Change[Up]));
  IF ErrorCode <> 0 THEN Exit;

  SEEK(F,FILESIZE(F));
  CLOSE(F);
  IF IOError THEN ;

  IF IncludeRows OR IncludeCols THEN
    BEGIN
    IF Dest = 'Printer' THEN BEGIN
      CarefulWrite(Dest,OutChan,FALSE,ResetString+FF,ErrorCode);
      IF ErrorCode <> 0 THEN Exit;
      END;
    CLOSE(OutChan);
    IF IOError THEN ;
    IF (Mode = 'Batch') AND (Dest <> 'Screen') THEN StopPrint := TRUE
    ELSE
      BEGIN
      Message('Reprint output? (Y/N) : ');
      GetChar(Ch,['Y','N',#27]);
      IF Ch = 'Y' THEN
        BEGIN
        Message('Reprinting output - to Screen, Printer, File or None? (S,P,F or N) : ');
        GetChar(Ch,['S','P','F','N',#27]);
        CASE Ch OF
          'S' : Dest := 'Screen';
          'P' : Dest := 'Printer';
          'F' : Dest := 'File';
          END;
        Calc := False;
        Aborted := FALSE;
        StopPrint := FALSE;
        END;
      END;
    END;
UNTIL (Ch IN ['N',#27]) OR StopPrint;
Dest := OriginalDest;
END {of printsoln};

PROCEDURE Solve;
  LABEL 999;
  VAR
    R, OutGoing, OldOutgoing, TentOutgoing, InfeasRow : RowType;
    C, Incoming, OldIncoming, UnboundedCol : ColType;
    Optimal, Feasible, Empty, Unbounded : BOOLEAN;
    MinReal, HighestReal : RealType;
    I : INTEGER;

  PROCEDURE TestStopSolve;
    BEGIN
    Ch := READKEY;
    IF KEYPRESSED THEN Ch := READKEY;
    IF (Ch = ^C) OR (Ch = #27) THEN
      BEGIN
      Message('Re-edit matrix,Continue iterations,View tableau,Quit (R,C,V or Q) : ');
      GetChar(Ch,['R','C','V','Q',^M]);
      IF Ch = 'R' THEN
        BEGIN
        StopSolve := TRUE;
        IF Mode = 'Batch' THEN Mode := 'Matrix';
        END
      ELSE IF Ch = 'V' THEN DropIntoEditor := TRUE
      ELSE IF Ch = 'Q' THEN
        BEGIN
        Message('Are you sure you want to leave GULP (Y/N) : ');
        GetChar(Ch,['Y','N',#27]);
        IF Ch = 'Y' THEN HALT;
        END
      ELSE Message('');
      END;
    END;

PROCEDURE ErrorMessage(I : Integer);
  BEGIN
  Clear;WRITELN;WRITELN;
  Centre('Error');WRITELN;
  Centre('-----');WRITELN;
  WRITELN;
  CASE I OF
    2001 : BEGIN
           Centre('Problem infeasible in row ' + RowName[InfeasRow]);WRITELN;
           JumpToEditor := TRUE;
           END;
    2002 : BEGIN
           Centre('Problem unbounded, possibly in col ' + ColName[UnboundedCol]);WRITELN;
           JumpToEditor := TRUE;
           END;
    END {of case};
  Message('Re-edit matrix,Print output,View tableau,Quit (R,P,V,Q) : ');
  GetChar(Ch,['P','R','V','Q',^M]);
  IF Ch = 'P' THEN
    BEGIN
    IncludeRange := FALSE;
    JumpToEditor := FALSE; {so that soln will print in main}
    END
  ELSE IF Ch = 'Q' THEN
    BEGIN
    Message('Are you sure you want to leave GULP (Y/N) : ');
    GetChar(Ch,['Y','N',#27]);
    IF Ch = 'Y' THEN HALT;
    END
  ELSE IF Ch = 'V' THEN Edit(WorkFile);
  END {of errormessage};

  PROCEDURE SetUpMatrix;
    VAR R,C : INTEGER;
    BEGIN
    MinReal := 1.0E-08; A[ObjFn]^[RHS] := 0;
    NoLs := 0; NoEs := 0; NoGs := 0;
    FOR R := 1 TO NoRows DO
      BEGIN
      {store original rhs}
      OriginalRHS[R] := A[R]^[RHS];

      {purturb zero rhs terms}
      IF A[R]^[RHS] = 0 THEN
        BEGIN
        A[R]^[RHS] := 1;
        FOR C := 1 TO NoCols DO
          IF A[R]^[C] < 0 THEN A[R]^[RHS] := A[R]^[RHS] - A[R]^[C];
        A[R]^[RHS] := A[R]^[RHS] * 1.0E-15;
        END {of if};

      {reverse equations with wrong direction}
      IF ConstraintType[R] IN ['E','G'] THEN
        FOR C := RHS TO NoCols DO
          IF A[R]^[C] <> 0 THEN A[R]^[C] := -A[R]^[C];

      {count Ls, Es and Gs}
      CASE ConstraintType[R] OF
        'L' : NoLs := NoLs + 1;
        'E' : NoEs := NoEs + 1;
        'G' : NoGs := NoGs + 1;
        END {of case};
      END {of for};

    FOR C := 1 TO NoCols DO
      BEGIN
      {store original objfn}
      OriginalObjFn[C] := A[ObjFn]^[C];

      {set problem direction}
      A[ObjFn]^[C] := A[ObjFn]^[C] * -Problem.Multiplier;

      {purturb zero objective function values}
      IF A[ObjFn]^[C] = 0 THEN
        BEGIN
        A[ObjFn]^[C] := 1;
        FOR R := 1 TO NoRows DO
          IF A[R]^[C] > 0 THEN A[ObjFn]^[C] := A[ObjFn]^[C] + A[R]^[C];
        A[ObjFn]^[C] := A[ObjFn]^[C] * 1.0E-13;
        END {of if};
      END {of for};

    {set up other bits and pieces}
    Feasible := TRUE;
    Optimal := FALSE;
    Empty := FALSE;
    Unbounded := FALSE;
    It := 0;
    END {of setupmatrix};

  PROCEDURE Iterate;
    VAR
      C : ColType;
      R : RowType;
      Smallest : RealType;
      S1, S2 : ScreenString;

    PROCEDURE SteepestAscent;
      VAR
        SubstObjFn : RealType;
        R,C : INTEGER;
      BEGIN
      {find incoming col}
      Incoming := 0;
      Smallest := 0;
      FOR C := 1 TO NoCols DO
        IF NOT ((ActThisCol[C] < 0) AND
            (ConstraintType[-ActThisCol[C]] = 'E')) THEN
          BEGIN
          IF Feasible THEN SubstObjFn := A[ObjFn]^[C]
          ELSE
            BEGIN
            SubstObjFn := 0;
            FOR R := 1 TO NoRows DO
              IF A[R]^[RHS] < 0 THEN
                SubstObjFn := SubstObjFn + A[R]^[C];
            END {of else};
          IF SubstObjFn < Smallest THEN
            BEGIN
            Smallest := SubstObjFn;
            Incoming := C;
            END {of if};
          END {of if and for};
      IF Incoming = 0 THEN
        IF Feasible THEN Optimal := TRUE
        ELSE
          BEGIN
          R := 0;
          Feasible := TRUE;
          WHILE (R < NoRows) AND Feasible DO
            BEGIN
            R := R + 1;
            IF A[R]^[RHS] < 0 THEN
              BEGIN
              InfeasRow := R;
              Feasible := FALSE;
              Empty := TRUE;
              END {of if};
            END {of while};
          END {of ELSE};

      {find outgoing row}
      Outgoing := 0;
      Smallest := 1.0E+30;
      FOR R := 1 TO NoRows DO
        IF (A[R]^[RHS]*A[R]^[Incoming] > 0) AND
                  (ABS(A[R]^[Incoming]) > MinReal) THEN
          IF A[R]^[RHS]/A[R]^[Incoming] < Smallest THEN
            BEGIN
            Smallest := A[R]^[RHS]/(A[R]^[Incoming]);
            Outgoing := R;
            END {of if, if and for};
      IF Outgoing = 0 THEN
        BEGIN
        Unbounded := TRUE;
        UnboundedCol := Incoming;
        END;
      END {steepestascent};

    PROCEDURE HighestStep;
      LABEL 99;
      VAR
        C : ColType;
        R, SPRow, LNRow : RowType;
        DualRatio, SubstObjFn, Ratio, SPRatio, LNRatio : RealType;
        Preferred : BOOLEAN;
      BEGIN
      HighestReal := 0;
      DualRatio := 1.0E+12;
      Incoming := 0; Outgoing := 0;
      C := 0;
      WHILE (C < NoCols) AND NOT Unbounded DO
        BEGIN
        C := C + 1;
        TentOutgoing := 0;
        IF NOT ((ActThisCol[C] < 0) AND (ConstraintType[-ActThisCol[C]] = 'E'))
            AND ((NOT Feasible) OR (A[ObjFn]^[C]<0)) THEN
          BEGIN
          {set up substitute objfn}
          SubstObjFn := 0;
          Preferred := FALSE;
          IF NOT Feasible THEN FOR R := 1 TO NoRows DO
            IF A[R]^[RHS] < 0 THEN
              SubstObjFn := SubstObjFn + A[R]^[C];
          IF (SubstObjFn < -1.0E-07) OR Feasible THEN
            BEGIN
            {set up preference of this column}
            IF A[ObjFn]^[C] > 0 THEN SubstObjFn := 0.001 * SubstObjFn
            ELSE
              BEGIN
              SubstObjFn := SubstObjFn + A[ObjFn]^[C];
              Preferred := TRUE;
              END {of else};
            {if preferred, search for smallest ratio of positives
             (or of negative 'equals') else search for lesser of
             smallest positive ratio and largest negative ratio}
            SPRatio := 1.0E+15; SPRow := 0; R := 0;
            LNRatio := 0;       LNRow := 0;
            Unbounded := TRUE; {initialise unbounded}
            WHILE R < NoRows DO
              BEGIN
              R := R + 1;
              IF (A[R]^[RHS]*A[R]^[C] >= 0) AND (ABS(A[R]^[C]) > MinReal) THEN
                BEGIN
                Unbounded := FALSE;
                Ratio := A[R]^[RHS]/A[R]^[C];

                IF (A[R]^[C]<0){a[r]^[rhs]<0} AND NOT PREFERRED{a[objfn,c]>0} THEN
                  {check if dual ratio violated}
                  IF (R = Outgoing) AND (-A[ObjFn]^[C]/A[R]^[C] > DualRatio) AND
                       (A[ObjFn]^[Incoming] > 0) THEN GOTO 99
                  ELSE {check primal ratio}
                    IF (Ratio > LNRatio) THEN
                      BEGIN
                      LNRatio := Ratio;
                      LNRow := R;
                      END {of if};

                IF (A[R]^[RHS]*A[R]^[C]>0) OR {this is an equals row}
                    ((ActThisCol[-R] = -R) AND (ConstraintType[R]='E')) THEN
                  BEGIN
                  IF Ratio < SPRatio THEN
                    BEGIN
                    SPRatio := Ratio;
                    SPRow := R;
                    END {of if};
                  END {of if};
                END {of if};
              END {of while r};
            IF Unbounded THEN UnboundedCol := C;
            IF (LNRatio <= SPRatio) AND (LNRow > 0) THEN TentOutgoing := LNRow
            ELSE IF SPRow > 0 THEN TentOutgoing := SPRow;

            IF (TentOutgoing = Outgoing) THEN
              IF (A[Outgoing]^[C] < 0)   AND (A[Outgoing]^[RHS] < 0) AND
                 (A[ObjFn]^[Incoming]>0) AND (A[ObjFn]^[C] > 0) THEN
                IF A[Outgoing]^[C]/A[Outgoing]^[Incoming] < 0.1 THEN
                  TentOutgoing := 0
                ELSE IF (-A[ObjFn]^[C]/A[Outgoing]^[C] < DualRatio) THEN
                  HighestReal := 0;

            IF TentOutgoing > 0 THEN
              Ratio := A[TentOutgoing]^[RHS]/A[TentOutgoing]^[C]
            ELSE Ratio := 0;
            IF Ratio * -SubstObjFn >= HighestReal THEN
              BEGIN
              HighestReal :=  Ratio * -SubstObjfn;
              Outgoing := TentOutgoing;
              Incoming := C;

              IF (A[Outgoing]^[Incoming]<0) AND (A[Outgoing]^[RHS]<0)
                THEN DualRatio := -A[ObjFn]^[C]/A[Outgoing]^[C];
              {If Outgoing = 0 THEN SteepestAscent;}
              END {of if};
            END {of if};
          END {of if};
        99 : END {of while c};
      IF Incoming = 0 THEN
        IF Feasible THEN Optimal := TRUE
        ELSE
          BEGIN
          R := 0;
          Feasible := TRUE;
          WHILE (R < NoRows) AND Feasible DO
            BEGIN
            R := R + 1;
            IF A[R]^[RHS] < 0 THEN
              BEGIN
              Feasible := FALSE;
              InfeasRow := R;
              Empty := TRUE;
              END {of if};
            END {of while};
          END {of else};
      IF (Outgoing=OldOutgoing) AND (Incoming=OldIncoming) THEN SteepestAscent;
      OldOutgoing := Outgoing;
      OldIncoming := Incoming;
      END {of higheststep};

    PROCEDURE RowColOperations;
      VAR
        Pivot : RealType;
        R : RowType;
        C : ColType;
        TempInt : INTEGER;
      BEGIN
      Pivot := A[Outgoing]^[Incoming];
      TempInt := {ColThisAct[ActThisCol[Incoming]]  =}  Incoming;
      ColThisAct[ActThisCol[Incoming]] :=
                 {ColThisAct[ActThisCol[-Outgoing]] =} -Outgoing;
      ColThisAct[ActThisCol[-Outgoing]] := TempInt;
      TempInt := ActThisCol[Incoming];
      ActThisCol[Incoming] := ActThisCol[-Outgoing];
      ActThisCol[-Outgoing] := TempInt;

      FOR C := RHS TO NoCols DO
        A[Outgoing]^[C] := A[Outgoing]^[C]/Pivot;
      FOR R := ObjFn TO NoRows DO
        IF R <> Outgoing THEN
          BEGIN
          FOR C := RHS TO NoCols DO
            IF C <> Incoming THEN
              BEGIN
              A[R]^[C] := A[R]^[C] - A[Outgoing]^[C]*A[R]^[Incoming];
              IF (ABS(A[R]^[C]) < MinReal) THEN
                IF (R*C>0) OR {the coeff is -ve but not an infeasible E row}
                (A[R]^[C]<0) AND NOT ((ActThisCol[-R]=-R)AND(ConstraintType[R]='E'))
                  THEN A[R]^[C] := 0.0;
              END {of for};
          END {of if and for};
      FOR R := ObjFn TO NoRows DO
        BEGIN
        A[R]^[Incoming] := A[R]^[Incoming]/-Pivot;
        IF A[R]^[RHS]=0 THEN
          IF ((ActThisCol[-R] = -R) AND (ConstraintType[R] = 'E')) THEN
          ELSE A[R]^[RHS] := MinReal;
        END;
      A[Outgoing]^[Incoming] := 1/Pivot;
      END {of rowcoloperations};

  BEGIN {iterate}
  IF NOT Feasible THEN
    IF (Method1 = Highest) THEN HighestStep
    ELSE SteepestAscent;
  IF Feasible THEN
    IF (Method2 = Highest) THEN HighestStep
    ELSE SteepestAscent;
  IF (NOT Optimal OR NOT Feasible) AND (NOT Empty) AND (NOT Unbounded) THEN
    BEGIN
    It := It + 1;
    RowColOperations;
    STR(It:1,S1);
    STR(A[ObjFn]^[RHS]*Problem.Multiplier:1:2,S2);
    GOTOXY(1,ScreenHeight);
    WRITE(' ':20,'Iteration:',S1,' ':7-LENGTH(S1),'Objective:',S2,' ':10);
    END {of if};
  END {of iterate};

  BEGIN
  SetUpMatrix;
  IF NoEs + NoGs > 0 THEN
    BEGIN
    Feasible := FALSE;
    WHILE NOT Feasible AND NOT Unbounded AND NOT Empty AND NOT StopSolve DO
      BEGIN
      IF DropIntoEditor THEN Edit(WorkFile);
      Iterate;
      IF KEYPRESSED THEN TestStopSolve;
      END {of while};
    IF Empty THEN
      BEGIN
      ErrorMessage(2001); {problem infeasible}
      GOTO 999;
      END {of if};
    END {of if};
  Optimal := FALSE;
  WHILE NOT Optimal AND NOT Unbounded  AND NOT StopSolve DO
      BEGIN
      IF DropIntoEditor THEN Edit(WorkFile);
      Iterate;
      IF KEYPRESSED THEN TestStopSolve;
      END {of while};
  IF Unbounded THEN
      BEGIN
      ErrorMessage(2002);
      GOTO 999;
      END {of if};
  IF Optimal THEN Message('Optimal solution found');
999:END {of solve};
